/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: avalon_timer.h 7327 2013-04-05 06:53:27Z shigihara $
 */

/*
 *		ޥɥ饤СAvalon Timerѡ
 */

#ifndef TOPPERS_AVALON_TIMER_H
#define TOPPERS_AVALON_TIMER_H

#include "prc_sil.h"
#include "nios2.h"

/*
 *  Avalon Timer ϡɥ
 */

/*
 *  쥸
 */
#define AVALON_TIM_STATUS	(0x00U)
#define AVALON_TIM_CONTROL	(0x04U)
#define AVALON_TIM_PERIODL	(0x08U)
#define AVALON_TIM_PERIODH	(0x0CU)
#define AVALON_TIM_SNAPL	(0x10U)
#define AVALON_TIM_SNAPH	(0x14U)

/*
 *  ӥå
 */
#define AVALON_TIM_STATUS_RUN	UINT_C(0x02)
#define AVALON_TIM_STATUS_TO	UINT_C(0x01)

#define AVALON_TIM_CONTROL_STOP		UINT_C(0x08)
#define AVALON_TIM_CONTROL_START	UINT_C(0x04)
#define AVALON_TIM_CONTROL_CONT		UINT_C(0x02)
#define AVALON_TIM_CONTROL_ITO		UINT_C(0x01)


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͥ륿ޤΥ١ɥ쥹μơ֥
 *  åȰ¸
 */
extern const uint32	target_sys_clk_timer_base_table[];

/*
 *  ͥ륿ޤγֹμơ֥
 *  åȰ¸
 */
extern const uint32	target_sys_clk_timer_intno_table[];

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TO_USEC(clock)	((((SystemTimeUsType) (clock)) * 1000U) / TIMER_CLOCK)

/*
 *  ޥñ̤Ǥλ
 */
extern SystemTimeUsType get_tim_utime(void);

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ
 */
extern void target_timer_initialize(void);

/*
 *  ޤ߽
 *
 *  ޤưߤ
 */
extern void target_timer_terminate(void);

/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE TickType
target_timer_get_current(void)
{
	TickType	count;
	uint32		base = target_sys_clk_timer_base_table[x_core_id()];

	/* ʥåץ쥸˽񤭹ͤۡɤ */
	sil_wrw_iop((void *) (base + AVALON_TIM_SNAPL), 0x00U);

	/* ͤɤ߹ */
	count = sil_rew_iop((void *) (base + AVALON_TIM_SNAPL));
	count |= sil_rew_iop((void *) (base + AVALON_TIM_SNAPH)) << 16;

	return(TIMER_CLOCK - count);
}

/*
 *  ޳׵Υå
 */
LOCAL_INLINE boolean
target_timer_probe_int(void)
{
	uint32 base = target_sys_clk_timer_base_table[x_core_id()];

	return((sil_rew_iop((void *) (base + AVALON_TIM_STATUS)) & AVALON_TIM_STATUS_TO) != 0U);
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_AVALON_TIMER_H */
