/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_support.S 7617 2013-06-25 10:41:26Z fsi-dankei $
 */

/*
 *		åȰ¸
 */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)		/* ̵ޥ */
#define CAST(type, val)		(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "offset.h"
#include "prc_asm.inc"

/*
 *  ߶ػߥޥ
 */
.macro LOCK_ALL_INT sc_reg1, sc_reg2
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_PIE
	and   \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
.endm

/*
 *  ߶ػ߲ޥ
 */
.macro UNLOCK_ALL_INT sc_reg
	rdctl \sc_reg, status
	ori   \sc_reg, \sc_reg, %lo(STATUS_PIE)
	wrctl status, \sc_reg
.endm

/*
 *  OS߶ػߥޥ
 *  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 */
.macro OUTER_LOCK_OS_INT sc_reg1, sc_reg2
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_IL
	and   \sc_reg1, \sc_reg1, \sc_reg2
	ldw   \sc_reg2, %gprel(tmin_status_il)(gp)
	or    \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
	movi  \sc_reg1, 1
	my_ccb \sc_reg2
	stb   \sc_reg1, CCB_nested_lock_os_int_cnt(\sc_reg2)
	stw   zero, CCB_saved_status_il(\sc_reg2)
.endm

/*
 *  OS߶ػ߲ޥ
 *  ͥȤΰֳ¦ǸƤӽФ뤳ȤꤷƤ
 */
.macro OUTER_UNLOCK_OS_INT sc_reg1, sc_reg2
	my_ccb \sc_reg1
	stb   zero, CCB_nested_lock_os_int_cnt(\sc_reg1)
	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_IL
	and   \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
.endm

/*
 *  OS߶ػߥޥ
 */
.macro NESTED_LOCK_OS_INT sc_reg1, sc_reg2, sc_reg3, sc_reg4
	my_ccb \sc_reg4
	ldbu  \sc_reg1, CCB_nested_lock_os_int_cnt(\sc_reg4)
	bne   \sc_reg1, zero, 1f

	rdctl \sc_reg2, status
	andi  \sc_reg3, \sc_reg2, STATUS_IL
	stw   \sc_reg3, CCB_saved_status_il(\sc_reg4)

	movi  \sc_reg3, ~STATUS_IL
	and   \sc_reg3, \sc_reg2, \sc_reg3
	ldw   \sc_reg2, %gprel(tmin_status_il)(gp)
	or    \sc_reg3, \sc_reg3, \sc_reg2
	wrctl status, \sc_reg3

1:
	addi  \sc_reg1, \sc_reg1, 1
	stb   \sc_reg1, CCB_nested_lock_os_int_cnt(\sc_reg4)
.endm

/*
 *  OS߶ػ߲ޥ
 */
.macro NESTED_UNLOCK_OS_INT sc_reg1, sc_reg2, sc_reg3
	my_ccb \sc_reg3
	ldbu  \sc_reg1, CCB_nested_lock_os_int_cnt(\sc_reg3)
	subi  \sc_reg1, \sc_reg1, 1
	stb   \sc_reg1, CCB_nested_lock_os_int_cnt(\sc_reg3)

	bne   \sc_reg1, zero, 1f

	rdctl \sc_reg1, status
	movi  \sc_reg2, ~STATUS_IL
	and   \sc_reg1, \sc_reg1, \sc_reg2
	ldw   \sc_reg2, CCB_saved_status_il(\sc_reg3)
	or    \sc_reg1, \sc_reg1, \sc_reg2
	wrctl status, \sc_reg1
1:
.endm

 /*
  *  å : ץå
  */
.macro PUSH reg
	addi  sp, sp, -4
	stw   \reg, 0(sp)
.endm

 /*
  *  å : ݥå
  */
.macro POP reg
	ldw   \reg, 0(sp)
	addi  sp, sp, 4
.endm

/*
 *  㳰ȥ
 *  ץåξ֤ϡ
 *    status.PIEꥢ߶ػ
 *    status.IL㳰ȯ
 *    estatus㳰ȯstatusƤäƤ
 */
	.set noat
	.section .exceptions, "xa"
	.global exception_entry
	.balign  FUNCTION_ALIGN_SIZE
exception_entry:

	/*
	 *  TrapȽ
	 */
check_trap:
	ldw   et, -4(ea)               /* 㳰Ф̿ */
	xorhi et, et, 0x003b           /*  16bit             */
	xori  et, et, 0x683a           /*  16bit             */
	beq   et, zero, trap_handler   /* trap̿ΥХʥ 0x003b683a */

	/*
	 *  㳰ȥ
	 */
exception:
	/*
	 *  åڤؤԤ
	 *  ڤؤå(ξƤϤޤhook_savedspͥ褵)
	 *   ø⡼ɤhook_savedsp != 0 hook_savedsp
	 *   except_nest_cnt == 0  _ostkpt
	 *  ڤؤ襹åݥ󥿤et
	 */
	my_ccb et
	stw   r1, CCB_exception_temporary1(et)	/* r1쥸 */
	rdctl r1, estatus						/* CPU㳰ȯΥơ */
	andi  r1, r1, STATUS_U					/* CPU㳰ȯCPUư⡼ɥå */
	beq   r1, zero, 1f						/* ø⡼ɤξhook_savedspˤʤ */

	ldw   et, CCB_hook_savedsp(et)
	beq   zero, et, 1f
	br    3f

1:
	ldw   r1, CCB_except_nest_cnt(et)  /* ͥȲΥå */
	bne   zero, r1, 2f

	/*
	 *  C1ISR¹Ծ֤ȯϥåڤؤʤ
	 */
	rdctl   r1,   status
	andi    r1,   r1, STATUS_IL
	stw     r2,   CCB_exception_temporary2(et)
	ldw     r2,   %gprel(tmin_status_il)(gp)
	/*
	 *  r2 < r1ξ硤C1ISR¹Ծ֤ȯ㳰Ȥʤꡤr1ˣ
	 */
	cmpltu  r1,   r2, r1
	ldw     r2,   CCB_exception_temporary2(et)
	bne     zero, r1, 2f

	/*
	 *  åڤؤ
	 *  ڤؤ襹åݥ󥿤et
	 */
	my_core_id r1
	slli   r1, r1, 2
	movia  et, _ostkpt_table
	add    et, et, r1
	ldw    et, 0(et)						/* åݥ󥿤ؤ */
	br    3f

2:
	mov   et, sp


3:
	/*
	 *  ƥȤ¸
	 */
	addi  et, et, -76    /* 쥸¸ */
	stw   r2,   4(et)
	stw   r3,   8(et)
	stw   r4,  12(et)
	stw   r5,  16(et)
	stw   r6,  20(et)
	stw   r7,  24(et)
	stw   r8,  28(et)
	stw   r9,  32(et)
	stw   r10, 36(et)
	stw   r11, 40(et)
	stw   r12, 44(et)
	stw   r13, 48(et)
	stw   r14, 52(et)
	stw   r15, 56(et)
	stw   ra,  60(et)
	stw   ea,  64(et)
	stw   sp,  72(et)
	my_ccb r1
	ldw    r1,   CCB_exception_temporary1(r1)	/* 򤷤r1 */
	stw   at,   0(et)
	mov   sp,  et
	rdctl et,  estatus
	stw   et,  68(sp)

	/*
	 *  ץƥեåOS٥Ǽ¹Ԥ뤿OS߶ػ߾֤ˤ
	 *  OS߶ػ߾֤㳰ȯǽ뤿ᡤͥȴԤ
	 *  C1ISR¹Իȯϡͥ٥ޥOS߶ػ߾֤⤤ᡤ
	 *  status.ILѹʤ
	 *  㳰ϼξȯ
	 *   C1ISR¹Ծ֤ȯ
	 *   C1ISR¹Ծְʳȯ
	 *    OS߲֤ȯ
	 *    OS߶ػ߾֤ȯ
	 */

	/*
	 *  C1ISR¹Ծ֤ȯϲԤʤ
	 *  OS߶ػ߾֤ILͤstatus.ILͥ٤ʤC1ISR㳰ȯ
	 */
	rdctl r4,status
	andi  r7, r4, STATUS_IL
	ldw   r2, %gprel(tmin_status_il)(gp)
	bltu  r2, r7, exception_1

	/*
	 *  C1ISR¹Ծְʳȯ
	 */
	my_ccb r9
	ldbu  r3, CCB_nested_lock_os_int_cnt(r9)
	addi  r1, r3, 1
	stb   r1, CCB_nested_lock_os_int_cnt(r9)

	/*
	 *  OS߶ػ߾֤ȯstatusѹʤ
	 */
	bne   zero, r3, exception_1

	/*
	 *  OS߲֤ȯ
	 *  OS߶ػ߾֤Ȥ
	 *  㳰νиΥ꥿(eret)ˤstatus.IL㳰뤿ᡤ
	 *  saved_status_ilˤ¸ʤ
	 */
	movi  r3, ~STATUS_IL
	and   r3, r4, r3
	or    r3, r3, r2
	wrctl status, r3

exception_1:
	/*
	 *  CPU㳰ֹ, badaddr
	 *  ȯѹΤǳ߶ػ߲˼
	 */
	rdctl r5, exception
	rdctl r8, badaddr

	/*
	 *  㳰ȯ߶ػ߾֤Ǥʤ߶ػ߲֤Ȥ
	 */
	rdctl r3, estatus
	andi  r3, r3, STATUS_PIE
	beq   r3, zero, exception_2

	UNLOCK_ALL_INT r1

exception_2:
	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰ϡ̵¥롼פ
	 */
	ldb   r3, CCB_kerflg(r9)  /* kerflgFALSEʤ̵¥롼 */
	beq   zero, r3, infinity_loop

	/*
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	ldw   r3, CCB_except_nest_cnt(r9)
	addi  r3, r3, 1
	stw   r3, CCB_except_nest_cnt(r9)

#ifdef CFG_USE_PROTECTIONHOOK
	/* nios2_cpu_exp_*򤹤륹ڡ */
	addi  sp, sp, -16

	/* nios2_cpu_exp_no */
	my_core_id r6
	slli  r9, r6, 2
	movia r6, nios2_cpu_exp_no
	add   r6, r6, r9
	ldw   r7, 0(r6)
	stw   r7, 12(sp)
	/*
	 *  exception / 4㳰ֹ
	 */
	andi  r5, r5, ((1 << 7) - 1)
	srli  r5, r5, 2
	stw   r5, 0(r6)

	/* nios2_cpu_exp_pc */
	movia r6, nios2_cpu_exp_pc
	add   r6, r6, r9
	ldw   r7, 0(r6)
	stw   r7, 8(sp)

	/*
	 *  㳰ȯPC - 4
	 */
	ldw   r7, 64+16(sp)
	addi  r7, r7, -4
	stw   r7, 0(r6)

	/* nios2_cpu_exp_bad_addr */
	movia r6, nios2_cpu_exp_bad_addr
	add   r6, r6, r9
	ldw   r7, 0(r6)
	stw   r7, 4(sp)

	stw   r8, 0(r6)

	/* nios2_cpu_exp_bad_sp */
	movia r6, nios2_cpu_exp_sp
	add   r6, r6, r9
	ldw   r7, 0(r6)
	stw   r7, 0(sp)

	addi  r7, sp, 16
	stw   r7, 0(r6)

	/* եåȤ¸ */
	PUSH  r9
#else /* CFG_USE_PROTECTIONHOOK */
	/*
	 *  exception / 4㳰ֹ
	 */
	andi  r5, r5, ((1 << 7) - 1)
	srli  r5, r5, 2
#endif /* CFG_USE_PROTECTIONHOOK */

	movi  r4, E_OS_PROTECTION_EXCEPTION	/* [0..17] 礭㳰װϤä褿ν */
	movi  r3, TNUM_EXCH					/* 㳰װ[0..17] 礭ϥơ֥뻲Ȥʤ */
	bgeu  r5, r3, call_protectionhook

	movia r4, exc_code_tbl				/* 㳰Ѵơ֥ */
	add   r4, r4, r5
	ldb   r4, 0(r4)						/* OS顼ɼ */

call_protectionhook:

	call  call_protectionhk_main		/* ץƥեåθƤӽФ */

#ifdef CFG_USE_PROTECTIONHOOK
	/* եåȤ */
	POP   r9

	/* nios2_cpu_exp_no */
	ldw   r6, 12(sp)
	movia r7, nios2_cpu_exp_no
	add   r7, r7, r9
	stw   r6, 0(r7)

	/* nios2_cpu_exp_pc */
	ldw   r6, 8(sp)
	movia r7, nios2_cpu_exp_pc
	add   r7, r7, r9
	stw   r6, 0(r7)

	/* nios2_cpu_exp_bad_addr */
	ldw   r6, 4(sp)
	movia r7, nios2_cpu_exp_bad_addr
	add   r7, r7, r9
	stw   r6, 0(r7)

	/* nios2_cpu_exp_bad_sp */
	ldw   r6, 0(sp)
	movia r7, nios2_cpu_exp_sp
	add   r7, r7, r9
	stw   r6, 0(r7)

	/* nios2_cpu_exp_*򤷤ڡ᤹ */
	addi  sp, sp, 16
#endif /* CFG_USE_PROTECTIONHOOK */

ret_exc:
	/*
	 *  ץƥեåOS߶ػ߾֤Ǽ¹Ԥ
	 *  ret_int_1  eret  esatus -> status ǲ
	 */

	/*
	 *  ߡ㳰ΥͥȲΥǥ
	 */
	my_ccb r9
	ldw   r3, CCB_except_nest_cnt(r9)
	addi  r3, r3, -1
	stw   r3, CCB_except_nest_cnt(r9)

	/*
	 *  OS߶ػ߾֤β
	 */
	/*
	 *  C1ISR¹Ծ֤ȯOS߶ػ߾֤β򤷤ʤ
	 *  OS߶ػ߾֤ILͤstatus.ILͥ٤ʤC1ISRȯ㳰
	 *  r4statusݻret_exc_2Ǥ
	 */
	rdctl r4,status
	andi  r5, r4, STATUS_IL
	ldw   r6, %gprel(tmin_status_il)(gp)
	bltu  r6, r5, ret_exc_2

	/*
	 *  C1ISR¹Ծְʳȯ硤OS߶ػ߾֤β
	 *  㳰Υ꥿ˤstatus.IL㳰뤿ᡤstatus.ILιϤʤ
	 */
	ldbu  r3, CCB_nested_lock_os_int_cnt(r9)
	addi  r3, r3, -1
	stb   r3, CCB_nested_lock_os_int_cnt(r9)

	/*
	 *  㳰ȯ
	 *  ret_int_1 ߶ػ߾֤ǸƤӽФɬפ
	 */
ret_exc_2:
	andi  r4, r4, STATUS_PIE		/* statusPIEĤ */
	ldw   r1, 68(sp)				/* CPU㳰ȯstatus(estatus) */
	movi  r2, ~STATUS_PIE
	and   r1, r1, r2				/* etatusPIE򥯥ꥢ */
	or    r1, r1, r4				/* estatusPIEstatusPIEˤ */
	stw   r1, 68(sp)

	LOCK_ALL_INT  r1, r2
	br ret_int_1

	/*
	 *  ͥ뵯ưƤʤ˵CPU㳰̵¥롼
	 */
infinity_loop:
	br infinity_loop

	/*
	 *  ߥȥ
	 *  ٥ơ֥뤫 Os_Lcfg.c Ƴߤγߥȥ
	 *  饸פet˳ֹ桤p_ccb->exception_temporary2r2
	 *  ¸줿֤Ǽ¹Ԥ
	 *  ץåξ֤ϡ
	 *    status.PIEꥢ߶ػ
	 *    status.IL˼դߤγͥ٤å
	 *    estatus˳statusƤäƤ
	 */
	.global interrupt
	.balign  FUNCTION_ALIGN_SIZE
interrupt:
	addi  ea, ea, -4     /* Ϥǥ */

	/*
	 *  ø⡼ɤξ祹åؤʤ
	 *  etȤΤ򤹤
	 *  r2ϴexception_temporary2ѤߡOs_Lcfg.c
	 */
	my_ccb r2
	stw   et, CCB_exception_temporary1(r2)
	
	rdctl et, estatus
	andi  et, et, STATUS_U
	beq   et, zero, 1f

	/*
	 *  ø⡼ɤưƤϥƥॹåڤؤ
	 */
	ldw   et, CCB_p_runtsk(r2)		/* et  TCB */
	ldw   et, TCB_p_tinib(et)		/* et  ֥å */
	ldw   r2, TINIB_sstk(et)		/* r2  ƥॹå */
	ldw   et, TINIB_sstksz(et)		/* et  ƥॹå */
	add   et, r2, et

	br    2f

1:
	mov   et, sp

2:
	/* etˤڤؤspäƤ */
	my_ccb r2
	addi  et, et, -76    /* 쥸¸ */
	stw   at,   0(et)							/* at򥹥å¸ */
	mov   at,  r2
	ldw   r2,  CCB_exception_temporary2(at)
	stw   r2,   4(et)
	stw   r3,   8(et)
	stw   r4,  12(et)
	stw   r5,  16(et)
	stw   r6,  20(et)
	stw   r7,  24(et)
	stw   r8,  28(et)
	stw   r9,  32(et)
	stw   r10, 36(et)
	stw   r11, 40(et)
	stw   r12, 44(et)
	stw   r13, 48(et)
	stw   r14, 52(et)
	stw   r15, 56(et)
	stw   ra,  60(et)
	stw   ea,  64(et)
	ldw   r4,  CCB_exception_temporary1(at)		/* װr4˰ư */
	stw   sp,  72(et)
	mov   sp,  et
	rdctl et, estatus
	stw   et,  68(sp)

	/*
	 *  ¿ųߤȽ
	 */
	my_ccb r6
	ldw   r3, CCB_except_nest_cnt(r6)

	/*
	 *  ߡ㳰ΥͥȲΥ󥯥
	 */
	addi  r5, r3, 1
	stw   r5, CCB_except_nest_cnt(r6)

	bltu  zero, r3,  interrupt_1				/* ͥȤƤϥå̵ */

	/*
	 *  ˳
	 *  åݥ󥿤ؤ
	 */
	my_core_id r1
	slli   r1, r1, 2
	movia  r2, _ostkpt_table
	add    r2, r2, r1
	ldw    r2, 0(r2)
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸     */
	mov   sp, r2        /* åݥ󥿤ؤ */

interrupt_1:
	UNLOCK_ALL_INT r1

	/*
	 *  åΥХեå
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ֹ
	 */
	PUSH  r4

	/*
	 *  ¿ųߤξϥåΥå˥󥰤Ԥʤ
	 */
	bltu  zero, r3,  int_nested

	/*
	 *  åݥ󥿥å
	 */
	mov   r4,   zero								/* ץƥեå¹Ի˥åڤؤ򤷤ʤ */
	movi  r5,   PEOB_STACKMONITORING_INTERRUPT		/* ISRǤΥå˥ */
	ldw   r7,   4(sp)								/* ¸åݥ󥿤 */
	ldw   r6,   CCB_p_runtsk(r6)					/* ֥åƬɥ쥹 */
	ldw   r6,   TCB_p_tinib(r6)						/* ֥åƬɥ쥹 */
	ldw   r6,   TINIB_sstk(r6)						/* åƬɥ쥹 */
	bgtu  r7,   r6,  stack_monitoring_magic_number	/* åݥ > åƬξOK  */
	call  stack_monitoring_error
	br    stack_monitoring_exit

stack_monitoring_magic_number:
	/*
	 *  ޥåʥСå
	 */
	ldw   r8,  0(r6)								/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER					/* ޥåʥСμ */
	/*
	 *  ޥåʥС̤˲ʤ顤߽
	 *  ˳硤ߥååʤ
	 */
	beq   r8,  r6,  stack_monitoring_exit
	call  stack_monitoring_error					/* åޥåʥС˲NG  */
	br    stack_monitoring_exit

	/*
	 *  ¿ųߤξ
	 */
int_nested:
	/*
	 *  ߥåΥХեå
	 */
	/*
	 *  ḁ̊å
	 */
	my_core_id	r5
	slli  		r3,	r5,	2							/* ID4ܤƥեåȤ */
	movia		r2,	target_ici_intno_table			/* ֳֹ */
	add			r2,	r2,	r3
	ldw			r2,	0(r2)
	andi		r2,	r2,	0xFFFF						/* IDޥ */
	beq   		r4, r2, ici_nested					/* ֳߤȽ */

	/*
	 *  C2ISRˤ륹åСեå
	 */
	movia 		r2,	isr_p_isrcb_table				/* ISR֥åơ֥ƽФ */
	add	  		r2,	r2,	r3
	ldw	  		r2,	0(r2)

	slli		r5,	r4,	2							/* ֹ4ܤƥեåȤ */
	add	  		r2,	r2,	r5
	ldw	  		r5,	0(r2)
	ldw			r5,	ISRCB_p_isrinib(r5)				/* ֹбISRCBΥɥ쥹 */
	ldw   		r7,	ISRINIB_p_intinib(r5)			/* ֹбISRINIBΥɥ쥹 */
	ldw   		r7,	INTINIB_remain_stksz(r7)		/* ֹбåνɥ쥹 */
	br 			cmp_stksz

ici_nested:
	/*
	 *  ICISRˤ륹åСեå
	 */
	movia 		r2,	ici_remain_stksz				/* ICIѥḁ̊ɥ쥹 */
	add	  		r2,	r2,	r3
	ldw	  		r7,	0(r2)

cmp_stksz:
	movhi		r6,	%hiadj(_ostk_table)
	addi		r6,	r6,	%lo(_ostk_table)
	add			r6,	r6,	r3
	ldw			r6,	0(r6)							/* ߥåƬɥ쥹 */
	add   		r7,	r7,	r6							/* Ƭɥ쥹ISRλѤ륹å */
	movi  r4,	1									/* ץƥեå¹Ի˥åڤؤ򤹤 */
	movi  r5,   PEOB_STACKMONITORING_INTERRUPT		/* ISRǤΥå˥ */
	bleu  		sp,	r7,	stack_monitoring_error		/* SP <= Ƭɥ쥹ISRλѤ륹å ξNG  */

	/*
	 *  ޥåʥСå
	 */
	ldw   r7,   0(r6)							/* ޥåΰͼ */
	movia r6,   STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	bne   r7,   r6, stack_monitoring_error		/* ޥåʥС */
stack_monitoring_exit:

	/*
	 *  ֹ
	 */
	POP   r4
#endif /* CFG_USE_STACKMONITORING */

	/*
	 *  ǥѥåΤ᥷ƥѰդֳߤǤС
	 *  ٤ֳߥϥɥ餬ʤΤǡ¸
	 *  ԤХѥ¹Ԥ
	 *  װr4Ƥ롤³ǤѤ
	 *  r3(my_ccb)ͤret_int_ici_dispatchˤѤ
	 */
#ifdef USE_ICI_DIS_HANDER_BYPASS
	my_core_id r5
	slli  r3, r5, 2								/* ID4ܤƥեåȤ */
	movia r2, target_ici_intno_table			/* ֳֹ */
	add   r2, r2, r3
	ldw   r2, 0(r2)
	andi  r2, r2, 0xFFFF						/* IDޥ */
	bne   r4, r2, not_only_int_ici_dispatch		/* ֳߤȽ */
	my_ccb r3
	ldw   r2, CCB_ici_request_map(r3)
	beq   r2, zero, ret_int_ici_dispatch 		/* 桼ֳߤ׵Ǥ뤫Ƚ */

not_only_int_ici_dispatch:
#endif /* USE_ICI_DIS_HANDER_BYPASS */

	/*
	 *  callevel_stat ¸
	 */
	my_ccb r1
	ldh   r3, CCB_callevel_stat(r1)
	PUSH  r3

	/*
	 *  callevel_stat 
	 */
	ori   r6, r3, TCL_ISR2
	sth   r6, CCB_callevel_stat(r1)

	/*
	 *  run_trusted ¸
	 */
	ldb   r3, CCB_run_trusted(r1)
	PUSH  r3

	/*
	 *  run_trusted 
	 */
	movi  r3, TRUE
	stb   r3, CCB_run_trusted(r1)

	/*
	 *  p_runosap ¸
	 */
	ldw   r3, CCB_p_runosap(r1)
	PUSH  r3

	/*
	 *  p_runisr ¸
	 */
	ldw   r3, CCB_p_runisr(r1)
	PUSH  r3

	/*
	 *  p_runisr 
	 */
	my_core_id r7
	slli  r7, r7, 2
	movia r2, isr_p_isrcb_table
	add   r2, r2, r7
	ldw   r2, 0(r2)
	slli  r3, r4, 2                 /* ֹ4ܤƥեåȤ  */
	add   r2, r2, r3
	ldw   r5,0(r2)
	stw   r5, CCB_p_runisr(r1)

	/*
	 *  ߥϥɥΥɥ쥹ɤ߹
	 */
	movia r2, isr_table
	add   r2, r2, r7
	ldw   r2, 0(r2)
	add   r2, r2, r3
	ldw   r6, 0(r2)

	/*
	 *  p_runosap 
	 */
	beq   r5, zero, int_handler_call		/* p_runisr  NULL Ǥʤ */

	ldw   r2, ISRCB_p_isrinib(r5)			/* r2 <- ISR ֥åΥɥ쥹 */
	ldw   r2, ISRINIB_p_osapinib(r2)		/* r2 <- ISR °OSץꥱ */
	stw   r2, CCB_p_runosap(r1)				/* ¹ISR°OSץꥱ*/

int_handler_call:
	/*
	 *  ߥϥɥƤӽФ
	 */
	callr r6

	/*
	 *  ߥåΥХեå
	 *  ߤäåݥ󥿤äϤʤΤǡ
	 *  ޥåʥСåΤ߼»
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ޥåʥСå
	 */
	my_core_id r7
	slli  r7, r7, 2
	movia r6, _ostk_table
	add   r6, r6, r7
	ldw   r7, 0(r6)								/* ߥåƬɥ쥹 */
	ldw   r7, 0(r7)								/* ޥåΰͼ */
	movia r6, STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	movi  r4, 1									/* ץƥեå¹Ի˥åڤؤ򤹤 */
	movi  r5, PEOB_STACKMONITORING_INTERRUPT	/* ISRǤΥå˥ */
	bne   r7, r6, stack_monitoring_error		/* ޥåʥС */
#endif /* CFG_USE_STACKMONITORING */

	/*
	 *  C2ISRλå
	 */
	my_ccb r4
	ldw   r5, CCB_p_runisr(r4)
	beq   r5, zero, 1f	/* p_runisr  NULL Ǥʤλå */
	call  exit_isr2

1:
	/*
	 *  p_runisr 
	 */
	my_ccb r4
	POP   r3
	stw   r3, CCB_p_runisr(r4)

	/*
	 *  p_runosap 
	 */
	POP   r3
	stw   r3, CCB_p_runosap(r4)

	/*
	 *  run_trusted 
	 */
	POP   r3
	stb   r3, CCB_run_trusted(r4)

	/*
	 *  callevel_stat 
	 */
	POP   r3
	sth   r3, CCB_callevel_stat(r4)

/*
 *  ߥϥɥи
 */
ret_int:
	/*
	 *  except_nest_cntȥåڤؤδ֤OS߶ػߤˤ
	 *  ɬפ
	 *  衤ؤΥ꥿󤫡ٱǥѥåʬ
	 *  ؤΥ꥿ˤߤɬפǤꡤٱǥѥåˤ
	 *  ͥȴOS߶ػߤˤɬפ뤿ᡤǤϰö߶
	 *  ߤȤ
	 */
	LOCK_ALL_INT  r1, r2

	/*
	 *  ߡ㳰ΥͥȲΥǥ
	 */
	ldw   r3, CCB_except_nest_cnt(r4)
	addi  r3, r3, -1
	stw   r3, CCB_except_nest_cnt(r4)

	/*
	 *  ͥȲ0ʤ顤߸
	 */
	beq  zero, r3, ret_int_task

	/*
	 *  C2ISRߤΥ꥿ϳ߸
	 *  C2ISRǤ뤿᤽Τޤޥ꥿
	 */
	br    ret_int_1

	/*
	 *  ߸ξ
	 */
ret_int_task:
	ldw   r2, 0(sp)              /* åݥ󥿤᤹    */
	mov   sp, r2

	/*
	 *  褬ξ硤ǥѥåɬפ뤫å
	 */
	ldw   r5, CCB_p_schedtsk(r4)		/* r5 <- p_schedtsk */
	ldw   r4, CCB_p_runtsk(r4)			/* r4 <- p_runtsk */
	/*
	 *  ¹楿ʤ(C2ISR¹Υλ)ξϥǥѥ
	 *  ˹Ԥ
	 */
	beq   r4, zero, ret_int_task_1
	beq   r4, r5, ret_int_1      /* ǥѥåɬפʤг߸ */

	/*
	 *  Ǥϡ褬Ǥꡤåϡå
	 *  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
	 *  ߤػߤ֤ȤʤäƤ
	 */

ret_int_task_1:
	/*
	 *  OS߶ػ߾֤˰ܹԤ
	 *
	 *  λOS߶ػ߾֤ȤΤϡdispatcher¹Ԥݤ
	 *  OS߶ػ߾֤ˤʤäƤɬפ뤿Ǥ
	 *
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤC1ISRʳγߤƶػߤ
	 */
	OUTER_LOCK_OS_INT  r1, r2
	/* ret_int ߶ػ߾֤Ȥ */
	UNLOCK_ALL_INT r1

	/*
	 *  r4ˤp_runtskäƤ
	 */
	beq   r4, zero, dispatcher_0

	addi  sp,   sp, -36                /* ĤΥ쥸¸ */
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   fp,  32(sp)
	stw   sp,  TCB_sp(r4)         /* åTCB¸ */
	movia r2,  ret_int_r          /* ¹ԺƳϤTCB¸   */
	stw   r2,  TCB_pc(r4)
	br    dispatcher

	/*
	 *  ߡ㳰ǥƥ¸롼
	 */
ret_int_r:
	ldw   r16,  0(sp)       /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw   fp,  32(sp)
	addi  sp, sp, 36

	/*
	 *  ץ꥿եåDisableAllInterrupts()򤷤ϡ
	 *  estatusSTATUS_PIEȿǤ
	 */
	rdctl r2, status
	andi  r2, r2, STATUS_PIE
	ldw   r1, 68(sp)
	movi  r3, %lo(~STATUS_PIE)
	and   r1, r1, r3
	or    r1, r1, r2
	stw   r1, 68(sp)

	/*
	 *  esatus Ȥ߶ػߤȤ
	 */
	LOCK_ALL_INT  r1, r2

	OUTER_UNLOCK_OS_INT  r1, r2

	/*
	 *  ߤ롼
	 *  estatusѤ뤿߶ػ߾֤ǸƤӽФȡ
	 *  ߶ػ߾֤ϡeretˤ
	 *  eret  estatus -> status Ȥʤ뤿ᡤILϸ͡PIEϳߵ
	 *  ꤵ
	 */
ret_int_1:
	/*
	 *  쥸
	 */
	ldw   at,   0(sp)
	ldw   r2,   4(sp)
	ldw   r3,   8(sp)
	ldw   r4,  12(sp)
	ldw   r5,  16(sp)
	ldw   r6,  20(sp)
	ldw   r7,  24(sp)
	ldw   r8,  28(sp)
	ldw   r9,  32(sp)
	ldw   r10, 36(sp)
	ldw   r11, 40(sp)
	ldw   r12, 44(sp)
	ldw   r13, 48(sp)
	ldw   r14, 52(sp)
	ldw   r15, 56(sp)
	ldw   ra,  60(sp)
	ldw   ea,  64(sp)
	ldw   et,  68(sp)
	wrctl estatus, et
	ldw   sp,  72(sp)
	eret

/*
 *  ǥѥå׵ѤΥץåֳߤΥХѥ
 *
 *  ѰդƤ ici_handler ƤӽФ˥ǥѥå
 *  ƤӽФ
 *  r3(my_ccb)ͤäƤ뤳ȤꤷƤ
 */    
#ifdef USE_ICI_DIS_HANDER_BYPASS
ret_int_ici_dispatch:
	movi  r4, 1
	ldb   r2, %gprel(shutdown_reqflg)(gp)				/* åȥ׵ᤫΥå */
	beq   r4, r2, call_shtdown_os

	/*
	 *  ǥѥå׵
	 */
	my_core_id r8
	slli  r8, r8, 2
	movhi r6, %hiadj(target_core_int_base_table)
	addi  r6, r6, %lo(target_core_int_base_table)
	add   r6, r6, r8
	ldw   r6, 0(r6)
	stw   zero, 0(r6)									/* ׵Υꥢ */

	stb   zero, CCB_ici_disreqflg(r3)					/* ǥѥå׵ե饰Υꥢ */

	mov   r4, r3
	br    ret_int

call_shtdown_os:
	movi  r4, E_OS_SHUTDOWN_OTHER_CORE
	call  internal_shutdownallcores
#endif /* USE_ICI_DIS_HANDER_BYPASS */

/*
 *  ƥॵӥƽФΥեȥߤΤ
 *  Trap Handler
 */
	/*
	 *  Trapϥɥ
	 *   SC3ꥷƥॵӥΥȥ롼ȤƵǽ
	 *
	 *  ϡ
	 *    r2ǽ
	 *    r4,r5,r6,r7  ƥॵӥΥѥ᡼
	 *      Nios2 GCC ξ,ѥ᡼5İʾξϥåϤȤʤ뤬
	 *       AUTOSAR ΥƥॵӥΥѥ᡼Ϻ3 Τᡤʤ
	 *
	 *  ϡ
	 *   r2ƥॵӥ
	 *   Nios2GCCξϡr3ؿͤǤ뤬AUTOSAR ƥॵӥ
	 *   ͤ32bitʲΤr2ΤߤѤ
	 *
	 *  ǽ
	 *   1ƽиƥȤ¸ʥ꥿˻ѡ
	 *
	 *   2åءʥ桼åͥƥॹå
	 *     ƽиø⡼ɤξؤʤ
	 *       Ǥ˥ƥॹåߥåѤƤ뤿
	 *        ڤؤ
	 *
	 *   3ͥ륵ӥ
	 *     r2˳ǼƤ뵡ǽɤѤơƥॵӥơ֥뤫
	 *     ƽФԤƥॵӥƬɥ쥹
	 *
	 *   4ƥॵӥΤθƽ
	 *     (1) Ϥ
	 *     (2) trapƽФ߶ػ߾֤ˤ
	 *     (3) ƥॵӥΡʴؿˤθƽ
	 *     ƽФstatus쥸Ʊ񴹤Τeret
	 *
	 *   5ӥ롼
	 *     (1) ƽиƥȤ
	 *     (2) eretˤ뽪λʥ꥿
	 *
	 */
trap_handler:

	rdctl et, estatus			/* trapȯԻΥơ */
	andi  et, et, STATUS_U		/* trapȯԸCPUư⡼ɥå */
	beq   et, zero, 1f			/* ƽФø⡼ɤξϥå̵ */

	/*
	 *  Υեå롼¹hook_savedspΥեå롼
	 *  ¹Υå(_ostk)ˤʤäƤΤǡ³
	 *  åȤ
	 */
	my_ccb r8
	ldw   et, CCB_hook_savedsp(r8)
	bne   zero, et, 2f

	/*
	 *  Υå
	 *   ֥åΥƥॹåؤ
	 *    ȥ TCB  p_runtsk Τ
	 *   Υåϡ㳰ե졼˳Ǽ
	 */
	ldw   et, CCB_p_runtsk(r8)		/* et <- p_runtsk */
	ldw   et, TCB_p_tinib(et)		/* et  ֥å */
	ldw   r8, TINIB_sstk(et)		/* r8  ƥॹå */
	ldw   et, TINIB_sstksz(et)		/* et  ƥॹå */
	add   et, r8, et
	br    2f

1:
	mov   et, sp

2:
	/*
	 *  ƽФƥȤΥ
	 *
	 *      estatus(ƽФstatus)楷ƥॵӥѹ
	 *      뤬ư⡼ɤؤ˱ƶΤǥå¸
	 *      estatusγǼսؤ她å 0(sp)
	 */
	addi  et, et, -12    /* 쥸¸ */
	stw   ea,  4(et)
	stw   sp,  8(et)
	mov   sp,  et
	rdctl et, estatus
	stw   et,  0(sp)



	/*
	 *  ƥॵӥƽ
	 *   ͥ륷ƥॵӥؿ ʬ
	 *
	 *  ϡ
	 *   r2ǽ
	 */
	/*
	 *  ͥ륷ƥॵӥ
	 */
	movi r3, TMAX_SVCID			/* ͥΥƥॵӥֹκ */
	bgt  r2, r3, trp_SVC_err	/* ͤ礭ƽФΤᥨ顼 */

	movia r3, svc_table			/* ͥΥƥॵӥơ֥ */

	/*
	 *  ȥꥢɥ쥹
	 *  r2ϸǻȤΤǾ񤭤ʤ
	 */
	slli r8, r2, 2					/* r8 = r2 + r2 r2 */
	add  r3, r3, r8					/* r3 = r3 + r8  svc_table[r2] */
	ldw  ea, 0(r3)					/* 㳰Ϥ˥ƥॵӥƬϤ	*/

	br   trp_SVC_call

	/*
	 *  ʵǽɤꤷơƥॵӥȯԻν
	 */
trp_SVC_err:
	movia ea, no_support_service

trp_SVC_call:
	/*
	 *  ƽн
	 *   ϡ r2ǽ
	 *    ea㳰ꥢɥ쥹ˤ˥ȥꥢɥ쥹
	 *    estatusEU0ʥѥХ⡼ɡˤ
	 */


	/*
	 *  estatus  U = 0 PIE  trap ȯԤȤΤޤޡ
	 */
	rdctl et, estatus
	movi  r15, ~STATUS_U
	and   et, et, r15
	wrctl estatus, et

	/*
	 *  ra ϤʥƥॵӥϤ˸
	 *   ra  trp_SVC_ret
	 */
	movia ra, trp_SVC_ret

trp_SVC:
	eret	/* ƥॵӥ¹ */

trp_SVC_ret:

	/*
	 *  ʲνϳ߶ػ
	 *   status PIE  0   LOCK_ALL_INT ˤƼ»ܡ
	 *
	 *  Suspend*Interrupts/Resume*InterruptsкȤäƤ
	 *  StatusPIE  ¸Ƥ StatusȿǤ
	 */
	rdctl r15, status		/* Ƥꤵ줿 status PIE ¸ */

							/* ߶ػ߲ϡeret ǹԤ */

	ldw    r13, 0(sp)		/* ƥॵӥƽи Status */

	andi  r15, r15, (STATUS_PIE | STATUS_IL)
	movi  r14, ~(STATUS_PIE | STATUS_IL)
	and   r13, r13 ,r14
	or    r13, r13 , r15

	LOCK_ALL_INT    r14, r15				/* ߶ػ*/

	wrctl  estatus, r13		/* ߾֤򥻡֤ estatusȿ */

#ifdef PERF_TEST
	ldw   et, %gprel(cache_flash_flag)(gp)	/* åѡå */
	beq   et, zero, trp_cache_flash_no
	stw   zero, %gprel(cache_flash_flag)(gp)
	br    trp_SVC_another_path				/* ѡѥ */
trp_cache_flash_no:
#endif /* PERF_TEST */

	ldw   ea,  4(sp)
	ldw   sp,  8(sp)

	eret	/* ȥ꽪λ */

	/*
	 *  ååؿ
	 *    r4  Ѥ륹å
	 *   Ѥ륹å̤ĤäƤʤϥ顼
	 */
	.global  trustedfunc_stack_check
	.balign  FUNCTION_ALIGN_SIZE
trustedfunc_stack_check:
	my_ccb r3
	ldh   r1, CCB_callevel_stat(r3)
	andi  r2, r1, TCL_ISR2
	beq   r2, zero, trustedfunc_stack_check_1	/* TCL_TASK ξ jump */

	my_core_id r2
	slli  r2, r2, 2
	movhi r1, %hiadj(_ostk_table)
	addi  r1, r1, %lo(_ostk_table)
	add   r1, r1, r2
	ldw   r1, 0(r1)					/* ߥåƬɥ쥹 */

	br    trustedfunc_stack_check_2


trustedfunc_stack_check_1:
	ldw   r1, CCB_p_runtsk(r3)		/* r1 <- p_runtsk */
	ldw   r1, TCB_p_tinib(r1)
	ldw   r1, TINIB_sstk(r1)		/* sstkȤ */


trustedfunc_stack_check_2:
	add   r4, r4, r1				/* r4 <- r4(size) + r1 (stktop) */
	bltu  sp, r4, trustedfunc_stack_check_3		/* if(sp < r4) error jump	*/
	movi  r2, E_OK
	ret
trustedfunc_stack_check_3:
	movi  r2, E_OS_STACKINSUFFICIENT
	ret

#ifdef PERF_TEST
	/*
	 *  ǽ¬ åѡ
	 *
	 *   ǽ¬ѤΤ߾֤ȿǤʤɤϺ
	 *   ֤ƥȤΤߥꥹȥƤ
	 */
trp_SVC_another_path:

	ldw   ea,   4(sp)
	ldw   sp,   8(sp)    /* 쥸Υꥹȥ */

	movui et, 4096
trp_cache_flash:
	initi et
	addi et, et, -32
	bgt et, zero, trp_cache_flash

trp_SVC_another_path00:
	eret
#endif /* PERF_TEST */

/*
 *  ǥѥå
 */
	.global dispatch
	.balign  FUNCTION_ALIGN_SIZE
dispatch:
	/*
	 *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  
	 */
	addi  sp, sp, -40                /* 쥸¸ */
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw   fp,  32(sp)
	stw   ra,  36(sp)
	my_ccb r6
	ldw   r6, CCB_p_runtsk(r6)		/* r6 <- p_runtsk */
	stw   sp,  TCB_sp(r6)           /* åTCB¸ */
	movia r5,  dispatch_r			/* ¹ԳϤ¸        */
	stw   r5,  TCB_pc(r6)           /* ¹ԺƳϤTCB¸   */

#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ¹楿ΥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
	ldw   r6,  TCB_p_tinib(r6)					/* ֥åƬɥ쥹 */
	ldw   r6,  TINIB_sstk(r6)					/* åƬɥ쥹 */
	movi  r4,  1								/* ץƥեå¹Ի˥åڤؤ򤹤 */
	movi  r5,  PEOB_STACKMONITORING_DISPATCH	/* ǥѥåǤΥå˥ */
	bgtu  sp,  r6,  1f							/* åݥ <= åƬξNG  */
	call  stack_monitoring_error
	br    2f
	/*
	 *  ޥåʥСå
	 */
1:
	ldw   r7,  0(r6)							/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	beq   r7,  r6,  2f							/* ޥåʥС */
	call  stack_monitoring_error

2:
#endif /* CFG_USE_STACKMONITORING */

	br    dispatcher

dispatch_r:
	ldw   r16,  0(sp)               /* 쥸 */
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw   fp,  32(sp)
	ldw   ra,  36(sp)
	addi  sp, sp, 40
	ret

/*
 *  ǥѥåư
 */
	.global start_dispatch
	.balign  FUNCTION_ALIGN_SIZE
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 *  ǸƤӽФ롥ޤsp󥿥ƥѥåݥ
	 *  ξ֤ǸƤӽФ뤳ȤꤷƤ
	 *
	 *  dispatcherϡOS߶ػ߾֤ǸƤӽФ
	 */
	/* OS߶ػ߾ */
	OUTER_LOCK_OS_INT r1, r2
	/* ߶ػ߲֤ */
	UNLOCK_ALL_INT  r1
	br    dispatcher_0

	.global exit_and_dispatch_nohook
	.balign  FUNCTION_ALIGN_SIZE

	/*
	 *  λξPostTaskHookƽФʤ
	 *  ξΥȥǤ
	 */
exit_and_dispatch_nohook:

	br    dispatcher_0

	/*
	 *  ߤΥƥȤΤƤƥǥѥå
	 */
	.global exit_and_dispatch
	.balign  FUNCTION_ALIGN_SIZE
exit_and_dispatch:
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  ¹楿ΥåΥХեå
	 */
	/*
	 *  åݥ󥿥å
	 */
	my_ccb r6
	ldw   r6,  CCB_p_runtsk(r6)					/* ֥åƬɥ쥹 */
	beq   r6,  zero, dispatcher_0
	ldw   r6,  TCB_p_tinib(r6)					/* ֥åƬɥ쥹 */
	ldw   r6,  TINIB_sstk(r6)					/* åƬɥ쥹 */
	movi  r4,  1								/* ץƥեå¹Ի˥åڤؤ򤹤 */
	movi  r5,  PEOB_STACKMONITORING_TERMTASK	/* λǤΥå˥ */
	bgtu  sp,  r6,  1f							/* åݥ <= åƬξNG  */
	call  stack_monitoring_error
	br    2f
	/*
	 *  ޥåʥСå
	 */
1:
	ldw   r7,  0(r6)							/* åƬɥ쥹ޥåΰͼ */
	movia r6,  STACK_MAGIC_NUMBER				/* ޥåʥСμ */
	beq   r7,  r6,  2f							/* ޥåʥС */
	call  stack_monitoring_error

2:
#endif /* CFG_USE_STACKMONITORING */
	/* ǥѥåΡdispatcherˤ */

dispatcher:
	my_ccb r6
	ldw   r6,  CCB_p_runtsk(r6)					/* ֥åƬɥ쥹 */
	beq   r6,  zero, dispatcher_0

	/*
	 *  PostTaskHookθƤӽФ
	 */
#ifdef CFG_USE_POSTTASKHOOK
	movia r2, PostTaskHook
	beq   r2, zero, dispatcher_0
posttaskhook_call:
	movia r4, call_posttaskhook
	call  stack_change_and_call_func_1
#endif /* CFG_USE_POSTTASKHOOK */

dispatcher_0:
	/*
	 *  Υ롼ϡƥȡOS߶ػ߾֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ
	 */
#ifdef LOG_DSP_ENTER
	my_ccb r4
	ldw   r4, CCB_p_runtsk(r4)			/* r4 <- p_runtsk */
	beq   r4, zero, 1f
	call  log_dsp_enter
1:
#endif /* LOG_DSP_ENTER */

	my_ccb r4
	ldh   r5, CCB_callevel_stat(r4)
	andi  r6, r5, TSYS_DISALLINT
	beq   r6, zero, dispatcher_1

	andi  r5, r5, %lo(~TSYS_DISALLINT)
	sth	  r5, CCB_callevel_stat(r4)
	UNLOCK_ALL_INT    r2    /* ߶ػ߲֤ */

	/*
	 *  㳰ʳ/CPU㳰ˤΥͥȲstart_dispatch䡤dispatcher_3:
	 *  褿'1'ȤʤäƤ뤿ᡤåڤ괹塤
	 *  '0'˽
	 */

	/*
	 *  SC3ǤϥǥѥåMPUؤ
	 *      Nios2 MPUξϥС饤Ȥ
	 *  оݤȤΰ
	 *      Υåΰ
	 *      OSץꥱΥץ饤١ΰ
	 *  OSץꥱΥץ饤١ΰϸߤOSץꥱ
	 *  ؤOSץꥱƱǤ(ƱʤΤ)ؤʤ
	 *  OSץꥱξϲ̤Ǥ
	 *    p_runosap p_runtsk  RUNNING Υ°OSץꥱ
	 *  if(ǥѥå){
	 *       å
	 *       OSץꥱ
	 *  }
	 *  r4CCBäƤ
	 */
dispatcher_1:
	ldw   r5,   CCB_p_schedtsk(r4)				/* r5 <- p_schedtsk              */
	stw   r5,   CCB_p_runtsk(r4)				/* p_schedtsk  p_runtsk        */
	beq   r5,   zero, dispatcher_3				/* p_schedtsk뤫            */
	ldw   sp,   TCB_sp(r5)						/* TCB饿å */
	stw   zero, CCB_except_nest_cnt(r4)			/* 㳰ͥȲ'0'       */

	ldw   r3, TCB_p_tinib(r5)					/* r3 <- ֥åΥɥ쥹 */
	ldw   r2, TINIB_p_osapinib(r3)				/* r2 <- °OSץꥱ */
	stw   r2, CCB_p_runosap(r4)					/* p_runosap  ˼¹Ԥ륿OSץꥱ */

	ldb   r1, OSAPINIB_osap_trusted(r2)			/* r2 <- OSץꥱmode(꡿) */
	stb   r1, CCB_run_trusted(r4)
	bne   r1, zero, dispatcher_1_5				/* OSץꥱ(mode == 1)ξ Jump */

	ldw   r2, CCB_p_ctxstk(r4)					/* r2 <- MPUꤵƤ륿TCB */
	beq   r2, r5, dispatcher_1_5				/* p_ctxstk  ˼¹Ԥ륿TCBƱʤMPUؤ̵ */

	stw   r5, CCB_p_ctxstk(r4)					/* p_ctxstk <- ˼¹Ԥ륿TCB */

	ldw   r1, TINIB_mpubase(r3)					/* r1 <- mpubase */
	ldw   r2, TINIB_mpuacc(r3)					/* r2 <- mpuacc */

	wrctl mpubase, r1
	wrctl mpuacc,  r2

	ldw   r4, CCB_p_runosap(r4)					/* p_runosap  ˼¹Ԥ륿OSץꥱ */

	call  prc_set_osap_mpu

dispatcher_1_5:

#ifdef LOG_DSP_LEAVE
	my_ccb r5									/* r5 <- p_runtsk */
	ldw   r4,  CCB_p_runtsk(r5)
	call  log_dsp_leave
#endif /* LOG_DSP_LEAVE */

#ifdef CFG_USE_PRETASKHOOK
	movia r2, PreTaskHook
	beq   r2, zero, dispatcher_2
pretaskhook_call:
	movia r4, call_pretaskhook
	call  stack_change_and_call_func_1
#endif /* CFG_USE_PRETASKHOOK */

dispatcher_2:
	my_ccb r5									/* r5 <- p_runtsk */
	ldw   r5, CCB_p_runtsk(r5)
	ldw   r5, TCB_pc(r5)			/* TCB ¹ԺƳϤ   */
	jmp   r5

dispatcher_3:
	/*
	 *  OS߶ػ߾֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 *  򤹤
	 *
	 *  󥿥ƥȤڤؤsp󥿥ƥ
	 *  ѥåݥ󥿡except_nest_cnt1)ΤϡOS߶ػ߲
	 *  ȯ߽ˤɤΥåȤȤβ
	 *  ȡߥϥɥǤΥǥѥåɻߤȤ2Ĥΰ
	 *  ̣
	 */

	my_core_id r3
	slli   r3, r3, 2
	movia  r2, _ostkpt_table
	add    r2, r2, r3
	ldw    sp, 0(r2)						/* åݥ󥿤ؤ */
	my_ccb r4
	stw    zero, CCB_p_runosap(r4)			/* p_runosap  NULL ˤ */
	movi   r5, TCL_ISR2						/* callevel_stat C2ISR */
	sth    r5, CCB_callevel_stat(r4)
	movi   r5, 1							/* except_nest_cnt 1 */
	stw    r5, CCB_except_nest_cnt(r4)

	/*
	 *  OS߶ػ߲֤
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤ
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *
	 *  Ԥδ֤ϡp_runtskp_runosapNULLʡ0ˤꤷʤ
	 *  Фʤʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫GetTaskID
	 *  GetApplicationIDƤӽФݤưͤ˹פʤʤ
	 */
	OUTER_UNLOCK_OS_INT r1, r2

	nop
	nop
	nop
	nop

	/*
	 *  OS߶ػ߾֤
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤC1ISRʳγߤƶػߤ
	 *  å󥿥ƥȤΥåѤƤ뤿ᡤexcept_nest_cntϡ
	 *  '1'ΤޤޤȤ
	 */
	OUTER_LOCK_OS_INT r1, r2
	my_ccb r4
	movi  r5, TCL_TASK
	sth   r5, CCB_callevel_stat(r4)			/* callevel_stat TASK */
	br    dispatcher_1

	/*
	 *  åХեν
	 */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  åХեץƥեåƤӽФ
	 *  å򹹤˲ʤᡤߥåνͤѤ
	 *  r4 == 1 åڤؤ򤹤
	 *  r4 == 0 åڤؤ򤷤ʤ
	 *  r5ɤΥå˥󥰤
	 */
	.global stack_monitoring_error
	.balign  FUNCTION_ALIGN_SIZE
stack_monitoring_error:
	/*
	 *  r4==0ξǤ⡤_ostkptȤäƤΤǡ
	 *  except_nest_cnt򥤥󥯥ȤƤϤʤ
	 */
	my_ccb r1
	ldw   r2, CCB_except_nest_cnt(r1)		/* _ostkptȤexcept_nest_cnt򥤥󥯥Ȥ */
	addi  r2, r2, 1
	stw   r2, CCB_except_nest_cnt(r1)

	beq   r4, zero, stack_monitoring_error_1
	my_core_id r3
	slli   r3, r3, 2
	movia  r2, _ostkpt_table
	add    r2, r2, r3
	ldw    sp, 0(r2)						/* åݥ󥿤ؤ */

stack_monitoring_error_1:
	/*
	 *  ץƥեåOS߶ػ߾֤ǸƤӽФ
	 */
	NESTED_LOCK_OS_INT r1, r2, r3, r4

	movi  r4, E_OS_STACKFAULT					/* ץƥեåΰ */
	or    r4, r4, r5
	PUSH  ra
	call  call_protectionhk_main				/* ץƥեåƤӽФ */
	POP   ra

	my_ccb r1
	ldw   r2, CCB_except_nest_cnt(r1)
	subi  r2, r2, 1
	stw   r2, CCB_except_nest_cnt(r1)

	NESTED_UNLOCK_OS_INT r1, r2, r3
	ret
#endif /* CFG_USE_STACKMONITORING */

/*
 *  ϻ
 *
 *  dispatcherƤӽФ
 */

	.text
	.global start_stask_r
	.balign  FUNCTION_ALIGN_SIZE
start_stask_r:
	movia ra, exit_task					/* ra(ϡ <- exit_task */
	mov   r1, zero						/* ø⡼ɤư褦 */

	br    start_r

	.global start_utask_r
	.balign  FUNCTION_ALIGN_SIZE
start_utask_r:
	movia ra, exit_utask				/* ra(ϡ <- exit_utask */
	movi  r1, %lo(STATUS_U)				/* ø⡼ɤư褦 */

	/*
	 *  å򥷥ƥॹå桼åڤؤ
	 */
	my_ccb r4
	ldw   r4, CCB_p_runtsk(r4)			/* r4 <- p_runtsk */
	ldw   r4, TCB_p_tinib(r4)
	ldw   r5, TINIB_ustk(r4)
	ldw   r4, TINIB_ustksz(r4)
	add   r4, r5, r4
	mov   sp, r4

	br    start_r								/* .balign к 0x00000000 Τ jmp */

	.text
	.global start_r
	.balign  FUNCTION_ALIGN_SIZE
start_r:

	my_ccb r4
	ldw   r4, CCB_p_runtsk(r4)			/* r4 <- p_runtsk */
#ifdef CFG_USE_STACKMONITORING
	/*
	 *  SC3ǤϥλΤǡư˥ޥåʥС
	 *  
	 */
	ldw   r5, TCB_p_tinib(r4)
	ldw   r5, TINIB_sstk(r5)
	movia r6, STACK_MAGIC_NUMBER
	stw	  r6, 0(r5)
#endif /* CFG_USE_STACKMONITORING */


	/*
	 *  ץ쥿եåǳ߶ػߤƤС߶ػߤǥư
	 *   OS߶ػ߲˸ͥ(TCB.curpri)¹ͥ(TINIB.exepri)
	 *   ѹ(꥽)
	 */
	rdctl r2, status
	andi  r2, r2, STATUS_PIE
	or    r1, r1, r2
	ldw   r3, TCB_p_tinib(r4)
	ldb   r5, TINIB_exepri(r3)			/* TINIB.exepri -> TCB.curpri */
	stb   r5, TCB_curpri(r4)

	LOCK_ALL_INT  r4, r5

	/*
	 *  OS߶ػ߲֤
	 *  (ǥ)ͥ٥ޥ0Ǥ뤿ᡤͭʳߤƵĤ
	 *  λݸԤ
	 */
	OUTER_UNLOCK_OS_INT r4, r5

	ldw   ea, TINIB_task(r3)			/* ea <- μ¹ */
	wrctl estatus, r1					/* estatus <- r1 */
	eret								/* μ¹Գ */

	.global stack_change_and_call_func_1
	.global stack_change_and_call_func_2
	.balign  FUNCTION_ALIGN_SIZE
stack_change_and_call_func_1:
stack_change_and_call_func_2:

	PUSH  ra

	my_ccb r1
	ldw   r2, CCB_except_nest_cnt(r1)			/* r1 <- p_runtsk */
	addi  r3, r2, 1
	stw   r3, CCB_except_nest_cnt(r1)
	bne   zero, r2, 1f

	my_core_id r3
	slli  r3, r3, 2
	movia r2, _ostkpt_table
	add   r2, r2, r3
	ldw   r2, 0(r2)	/* r2 <- åݥ */
	addi  r2, r2, -4
	stw   sp, 0(r2)     /* åݥ󥿤¸     */
	mov   sp, r2        /* åݥ󥿤ؤ */
1:

	mov   r2, r4
	mov   r4, r5
	mov   r5, r6
	callr r2

	my_ccb r1
	ldw   r2, CCB_except_nest_cnt(r1)
	subi  r2, r2, 1
	stw   r2, CCB_except_nest_cnt(r1)
	bne   zero, r2, 1f

	ldw   sp, 0(sp)     /* åݥ󥿤     */
1:
	POP   ra
	ret

	/*
	 *  եåθƤӽФ
	 *  եåζλ
	 */
	.global call_trusted_hook
call_trusted_hook:

	addi  sp, sp, -52
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw    fp, 32(sp)

	/*
	 *  ꥿󥢥ɥ쥹
	 */
	stw   ra, 36(sp)

	my_ccb r3
	ldh   r7, CCB_callevel_stat(r3)
	sth   r7, 40(sp)
	ldw   r7, CCB_except_nest_cnt(r3)
	stw   r7, 44(sp)
	ldw   r7, CCB_trusted_hook_savedsp(r3)
	stw   r7, 48(sp)
	stw   sp, CCB_trusted_hook_savedsp(r3)

	mov   r2, r4
	mov   r4, r5
	callr r2
	br    trusted_hook_ret

	/*
	 *  եåζλ
	 */
	.global exit_trusted_shutdown_hook
exit_trusted_shutdown_hook:
	my_ccb r3
	ldw   sp, CCB_trusted_hook_savedsp(r3)
	ldh   r1, 40(sp)
	sth   r1, CCB_callevel_stat(r3)
	ldw   r1, 44(sp)
	stw   r1, CCB_except_nest_cnt(r3)
	ldw   r1, 48(sp)
	stw   r1, CCB_trusted_hook_savedsp(r3)

trusted_hook_ret:
	my_ccb r16
	stw   zero, CCB_trusted_hook_savedsp(r16)
	ldw   r16,  0(sp)
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw    fp, 32(sp)
	ldw    ra, 36(sp)
	addi  sp, sp, 52
	ret

/*
 *  ñ̡ø⡼ɡˤưΤǡͭΰ
 *  ֤.section .text_shared ֻؼƤ
 */
	/*
	 *  ꥿ TerminateTask ƽФʤǥؿλ
	 *  Ȥ˼¹Ԥ륳ɡʥӥץƥб
	 *  եȥߤˤƥͥΤ exit_task ƽФ
	 */
	.section .text_shared
	.balign  FUNCTION_ALIGN_SIZE
exit_utask:
	movi  r2, TFN_EXIT_TASK
	trap


	/*
	 *  Υեå롼ø⡼ɤǼ¹Ԥ뤿δؿ
	 */
	.global call_nontrusted_hook
	.balign  FUNCTION_ALIGN_SIZE
call_nontrusted_hook:

	addi  sp, sp, -68
	stw   r16,  0(sp)
	stw   r17,  4(sp)
	stw   r18,  8(sp)
	stw   r19, 12(sp)
	stw   r20, 16(sp)
	stw   r21, 20(sp)
	stw   r22, 24(sp)
	stw   r23, 28(sp)
	stw    fp, 32(sp)

	/*
	 *  ꥿󥢥ɥ쥹
	 */
	stw   ra, 36(sp)

	/*
	 *  hook_savedspϤ٤ƤΥեå롼ǻȤΤǡեå롼
	 *  ͥȤ򤹤
	 */
	my_ccb r3
	ldw   r1, CCB_hook_savedsp(r3)			/* r3 <- p_runtsk */
	stw   r1, 40(sp)

	ldw   r2, CCB_shutdown_hook_savedsp(r3)
	stw   r2, 44(sp)

	/*
	 *  ߤΥåݥ󥿤hook_savedsp򤹤
	 */
	stw   sp, CCB_hook_savedsp(r3)

	/*
	 *  ꥷåȥեåζλΤ˥å¸
	 *  callevel_stat⸵᤻褦¸
	 */
	movi  r7, SHUTDOWN_HOOK
	bne   r6, r7, 1f
	stw   sp, CCB_shutdown_hook_savedsp(r3)
	ldh   r7, CCB_callevel_stat(r3)
	sth   r7, 60(sp)
	ldw   r7, CCB_except_nest_cnt(r3)
	stw   r7, 64(sp)

1:
	/*
	 *  hook_savedsp == 0ξեå롼󤬥ͥȤƤʤ
	 */
	beq   r1, zero, call_nontrusted_hook_non_nest

	/*
	 *  r1եå롼ǻȤåݥ󥿤
	 *
	 *  hook_savedsp[-4]ΰ֤եå롼ǻȤäƤ
	 *  åݥ󥿤äƤ(CPU㳰ȯtrapȯ˥å
	 *  ݥ󥿤򤹤Τ)Τǡ³饹åȤ
	 */
	ldw   r1, -4(r1)

	/*
	 *  ¹OSAP != MPUꤷƤOSAPξ硤ƱOSAP°
	 *  եåͥȤƤʤΤǡMPU
	 *  㤦OSAP°եåͥȻեå뤳ȤʤΤǡ
	 *  MPUꤷƤOSAP¸ʤʰ㤦OSAPͥȤƤǸ
	 *  եåϥåȥեåʤ
	 */
	ldw   r7, CCB_p_ctxosap(r3)
	ldw   r8, CCB_p_runosap(r3)
	bne   r8, r7, call_diff_nontrusted_osap

	/*
	 *  ¹OSAP == MPUꤷƤOSAPξ硤ƱOSAP°
	 *  եåͥȤ
	 */
	br    call_nontrusted_hook_common

	/*
	 *  ͥȤƤʤեå롼θƤӽФ
	 */
call_nontrusted_hook_non_nest:

	/*
	 *  եå롼ǻȤå(_nthkstk)Τ
	 *  ɤ߽񤭤Ǥ褦MPUꤹ
	 *  åѤMPU̵ơեå롼
	 *  ѤMPUͭˤ
	 *  åѤƱMPUȤᡤ򹹿
	 *
	 *  r1 <- _nthkstk + _nthkstksz
	 */

	my_core_id r7
	slli  r7, r7, 2
	movia r8, _nthkstk_table
	add   r8, r8, r7
	ldw   r1, 0(r8)		/* եååƬɥ쥹 */
	ori   r2, r1, (NIOS2_MPU_STACK_REGION << NIOS2_MPU_INDEX_SHIFT) | NIOS2_MPU_DATA_REGION
	movia r8, _nthkstksz_table
	add   r8, r8, r7
	ldw   r3, 0(r8)
	add   r1, r1, r3
#ifdef NIOS2_USE_DATACACHE
	ori   r3, r1, (NIOS2_MPU_CACHEABLE << NIOS2_MPU_CACHEABLE_SHIFT) | (NIOS2_MPU_PERM_SYS_RW_USR_RW << NIOS2_MPU_PERM_SHIFT) | NIOS2_MPU_WRITE
#else
	ori   r3, r1, (NIOS2_MPU_PERM_SYS_RW_USR_RW << NIOS2_MPU_PERM_SHIFT) | NIOS2_MPU_WRITE
#endif /* NIOS2_USE_DATACACHE */
	wrctl mpubase, r2
	wrctl mpuacc, r3


	/*
	 *  ¹OSAP != MPUꤷƤOSAPξ硤㤦OSAP°
	 *  եåͥȤƤΤǡMPU
	 */
call_diff_nontrusted_osap:
	/*
	 *  OSAPͭΰMPU
	 *  r6ϻȤʤΤ򤷤ʤ
	 */
	my_ccb r3
	stw   r4, 48(sp)
	stw   r5, 52(sp)
	stw   r1, 56(sp)
	ldw   r4, CCB_p_runosap(r3)
	call  prc_set_osap_mpu
	ldw   r4, 48(sp)
	ldw   r5, 52(sp)
	ldw   r1, 56(sp)

	/*
	 *  MPUꤷƤ륹åͭ륿TCBΥå¸
	 */
	my_ccb r3
	ldw   r2, CCB_p_ctxstk(r3)
	stw   r2, 48(sp)
	stw   zero, CCB_p_ctxstk(r3)

	/*
	 *  ϥͥȡͥȤ˴ؤ餺¹Ԥ
	 */
call_nontrusted_hook_common:

	/*
	 *  åݥ󥿤եå롼Υåڤؤ
	 */
	mov   sp, r1

	/*
	 *  ø⡼ɤڤؤ
	 */
	rdctl r1, status
	ori   r1, r1, STATUS_U

	LOCK_ALL_INT  r2, r3
	wrctl estatus, r1

	/*
	 *  եå롼¹
	 *  r4 : եå롼Υɥ쥹
	 *  r5 : 
	 */
	mov   ea, r4
	mov   r4, r5
	movia ra, exit_nontrusted_hook

	eret

	/*
	 *  ꥷåȥեåζλ
	 */
	.global exit_nontrusted_shutdown_hook
exit_nontrusted_shutdown_hook:
	my_ccb r3
	ldw   sp, CCB_shutdown_hook_savedsp(r3)
	ldh   r1, 60(sp)
	sth   r1, CCB_callevel_stat(r3)
	ldw   r1, 64(sp)
	stw   r1, CCB_except_nest_cnt(r3)
	br    call_nontrusted_hook_ret_common

	/*
	 *  trapΥ꥿
	 *  ø⡼ɤư
	 *  åݥ󥿤trapѤäƤʤ
	 */
	.global call_nontrusted_hook_trap_ret
call_nontrusted_hook_trap_ret:

	my_ccb r3
	ldw   r1, CCB_hook_savedsp(r3)

	/*
	 *  hook_savedsp==0ξ(trap)ϥ꥿󤹤
	 */
	bne   r1, zero, 1f
	ret

1:
	/*
	 *  å򥷥ƥॹå᤹
	 */
	mov   sp, r1

call_nontrusted_hook_ret_common:
	/*
	 *  hook_savedsp򤷤Ƥ᤹ͤ
	 */
	ldw   r1, 40(sp)
	stw   r1, CCB_hook_savedsp(r3)

	ldw   r2, 44(sp)
	stw   r2, CCB_shutdown_hook_savedsp(r3)

	/*
	 *  ͥȤξ(hook_savedsp != 0)Ϥǥ꥿
	 *  㤦OSAP°եåͥȤƤ⡤Υեå뤳ȤʤΤǡ
	 *  MPUʤʰ㤦OSAPͥȤƤǸΥեåϥåȥ
	 *  եåʤ
	 */
	bne   r1, zero, call_nontrusted_hook_ret

	/*
	 *  ʹߤϥͥȤƤʤν
	 */

	/*
	 *  åMPU򸵤᤹
	 *  åѤƱMPUȤᡤ򹹿
	 */
	ldw   r4, 48(sp)
	stw   r4, CCB_p_ctxstk(r3)
	beq   r4, zero, call_nontrusted_hook_ret
	ldw   r4, TCB_p_tinib(r4)
	ldw   r3, TINIB_mpubase(r4)
	ldw   r4, TINIB_mpuacc(r4)
	wrctl mpubase, r3
	wrctl mpuacc, r4

call_nontrusted_hook_ret:
	ldw   r16,  0(sp)
	ldw   r17,  4(sp)
	ldw   r18,  8(sp)
	ldw   r19, 12(sp)
	ldw   r20, 16(sp)
	ldw   r21, 20(sp)
	ldw   r22, 24(sp)
	ldw   r23, 28(sp)
	ldw    fp, 32(sp)
	ldw    ra, 36(sp)
	addi  sp, sp, 68
	ret

exit_nontrusted_hook:
	movi  r2, TFN_HOOK_RETURN
	trap
