/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: interrupt.c 7571 2013-06-14 10:51:58Z fsi-dankei $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "interrupt.h"
#include "mc.h"

#ifdef TOPPERS_interrupt_initialize

/*
 *  ߴǽν
 */
#ifndef OMIT_INITIALIZE_INTERRUPT

void
interrupt_initialize(void)
{
	ISRType				i;
	InterruptNumberType	j;
	ISRCB				*p_isrcb;
	const INTINIB		*p_intinib;
	CCB					*my_p_ccb;
	const ICIINIB		*p_iciinib;
	CoreIdType			coreid = x_core_id();

	/* C2ISRICISRν */
	for (i = 0U; i < tnum_isr2; i++) {
		if (isrinib_table[i].p_osapinib->coreid == coreid) {
			p_isrcb = p_isrcb_table[i];
			p_isrcb->p_isrinib = &(isrinib_table[i]);
			p_isrcb->p_lastrescb = NULL;
			p_isrcb->p_lastspncb = NULL;
#ifdef CFG_USE_PROTECTIONHOOK
			p_isrcb->calltfn = FALSE;
#endif /* CFG_USE_PROTECTIONHOOK */
		}
	}

	for (j = 0U; j < tnum_intno; j++) {
		if (intinib_table[j].coreid == coreid) {
			p_intinib = &(intinib_table[j]);
			x_config_int(p_intinib->intno, p_intinib->intatr, p_intinib->intpri);
		}
	}

	/* ICISRν */
	my_p_ccb = get_my_p_ccb();
	my_p_ccb->ici_bit_mask = 0U;
	p_iciinib = p_iciinb_table[my_p_ccb->coreid];
	for (j = 0; j < tnum_ici_of_core[my_p_ccb->coreid]; j++) {
		/*
		 *  桼ICISR
		 *  ե졼ENABLEȤICISRΤߤĤ
		 */
		if ((p_iciinib[j].iciatr & ENABLE) != 0U) {
			my_p_ccb->ici_bit_mask |= p_iciinib[j].ici_bit_ptn;
		}
	}
}

#endif /* OMIT_INITIALIZE_INTERRUPT */
#endif /* TOPPERS_interrupt_initialize */

/*
 *  ߶ػߤβ
 */
#ifdef TOPPERS_release_interrupts

void
release_interrupts(OSServiceIdType serviceId)
{
	boolean call_error_hook = FALSE;
	CCB		*p_ccb = get_my_p_ccb();

	if (p_ccb->sus_os_cnt_ctx > 0U) {
		p_ccb->sus_os_cnt -= p_ccb->sus_os_cnt_ctx;
		p_ccb->sus_os_cnt_ctx = 0U;

		if (p_ccb->sus_os_cnt == 0U) {
			LEAVE_CALLEVEL(TSYS_SUSOSINT);
			x_nested_unlock_os_int();
		}
		call_error_hook = TRUE;
	}

	if (p_ccb->sus_all_cnt_ctx > 0U) {
		p_ccb->sus_all_cnt -= p_ccb->sus_all_cnt_ctx;
		p_ccb->sus_all_cnt_ctx = 0U;
		if (p_ccb->sus_all_cnt == 0U) {
			LEAVE_CALLEVEL(TSYS_SUSALLINT);
			ASSERT((p_ccb->callevel_stat & TSYS_DISALLINT) == TSYS_NULL);
			x_unlock_all_int();
		}
		call_error_hook = TRUE;
	}

	/* C2ISRξΤDisAll */
	if (serviceId == OSServiceId_ISRMissingEnd) {
		if ((p_ccb->callevel_stat & TSYS_DISALLINT) != TSYS_NULL) {
			LEAVE_CALLEVEL(TSYS_DISALLINT);
			x_unlock_all_int();
			call_error_hook = TRUE;
		}
	}

#ifdef CFG_USE_ERRORHOOK
	if ((serviceId != OSServiceId_Invalid) && (call_error_hook != FALSE)) {
		call_errorhook(E_OS_DISABLEDINT, serviceId);
	}
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_release_interrupts */

/*
 *  C2ISRλΥåؿ
 */
#ifdef TOPPERS_exit_isr2

void
exit_isr2(void)
{
	CCB *p_ccb = get_my_p_ccb();

	x_nested_lock_os_int();

	/* ԥåޤޤξϥԥå */
	if (p_ccb->p_runisr->p_lastspncb != NULL) {
		release_isrspinlocks(p_ccb->p_runisr);
#ifdef CFG_USE_ERRORHOOK
		call_errorhook(E_OS_SPINLOCK, OSServiceId_ISRMissingEnd);
#endif /* CFG_USE_ERRORHOOK */
	}

	release_interrupts(OSServiceId_ISRMissingEnd);

	/* ꥽ݾ֤ξ */
	if (p_ccb->p_runisr->p_lastrescb != NULL) {
		release_isrresources(p_ccb->p_runisr);
#ifdef CFG_USE_ERRORHOOK
		call_errorhook(E_OS_RESOURCE, OSServiceId_ISRMissingEnd);
#endif /* CFG_USE_ERRORHOOK */
	}
	x_nested_unlock_os_int();
}

#endif /* TOPPERS_exit_isr2 */

/*
 *  C2ISR꥽ֵ
 */
#ifdef TOPPERS_release_isrresources

void
release_isrresources(ISRCB *p_isrcb)
{

	/* OS߶ػ߾ְʾϤ */
	while (p_isrcb->p_lastrescb != NULL) {
		x_set_ipm(p_isrcb->p_lastrescb->prevpri);
		p_isrcb->p_lastrescb->lockflg = FALSE;
		p_isrcb->p_lastrescb = p_isrcb->p_lastrescb->p_prevrescb;
	}
}

#endif /* TOPPERS_release_isrresources */

/*
 *  C2ISRԥåֵ
 */
#ifdef TOPPERS_release_isrspinlocks

void
release_isrspinlocks(ISRCB *p_isrcb)
{
	SPNCB *p_spncb;

	p_spncb = p_isrcb->p_lastspncb;

	/* OS߶ػ߾ְʾϤ */
	while (p_spncb != NULL) {
		acquire_spn_lock(GET_SPNLOCK());

		p_spncb->p_ccb = NULL;
		p_isrcb->p_lastspncb = p_spncb->p_prevspncb;
		p_spncb->p_prevspncb = NULL;
		p_spncb->p_holdcb = NULL;

		release_spn_lock(GET_SPNLOCK());

		if (p_spncb->p_spninib->resint != NULL) {
			p_spncb->p_spninib->resint();
		}
		p_spncb = p_isrcb->p_lastspncb;
	}
}

#endif /* TOPPERS_release_isrspinlocks */
