/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: mc_manage.c 7648 2013-06-27 12:38:07Z fsi-dankei $
 */

/*
 *		ޥ⥸塼
 */
#include "kernel_impl.h"
#include "mc.h"
#include "target_ici.h"
#include "task.h"
#include "interrupt.h"
#include "check.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_RASICI_ENTER
#define LOG_RASICI_ENTER(ISRID)
#endif /* LOG_RASICI_ENTER */

#ifndef LOG_RASICI_LEAVE
#define LOG_RASICI_LEAVE(ercd)
#endif /* LOG_RASICI_LEAVE */

#ifndef LOG_GETCOREID_ENTER
#define LOG_GETCOREID_ENTER()
#endif /* LOG_GETCOREID_ENTER */

#ifndef LOG_GETCOREID_LEAVE
#define LOG_GETCOREID_LEAVE(coreid)
#endif /* LOG_GETCOREID_LEAVE */

#ifndef LOG_STARTCORE_ENTER
#define LOG_STARTCORE_ENTER(CoreID)
#endif /* LOG_STARTCORE_ENTER */

#ifndef LOG_STARTCORE_LEAVE
#define LOG_STARTCORE_LEAVE(ercd, p_status)
#endif /* LOG_STARTCORE_LEAVE */

#ifndef LOG_STARTNONAUTOSARCORE_ENTER
#define LOG_STARTNONAUTOSARCORE_ENTER(CoreID)
#endif /* LOG_STARTNONAUTOSARCORE_ENTER */

#ifndef LOG_STARTNONAUTOSARCORE_LEAVE
#define LOG_STARTNONAUTOSARCORE_LEAVE(ercd, p_status)
#endif /* LOG_STARTNONAUTOSARCORE_LEAVE */

#ifndef LOG_GETNUMOFACTCORES_ENTER
#define LOG_GETNUMOFACTCORES_ENTER()
#endif /* LOG_GETNUMOFACTCORES_ENTER */

#ifndef LOG_GETNUMOFACTCORES_LEAVE
#define LOG_GETNUMOFACTCORES_LEAVE(activated_cores)
#endif /* LOG_GETNUMOFACTCORES_LEAVE */

#ifndef LOG_SHUTDOWNALLCORES_ENTER
#define LOG_SHUTDOWNALLCORES_ENTER(Error)
#endif /* LOG_SHUTDOWNALLCORES_ENTER */

#ifndef LOG_SHUTDOWNALLCORES_LEAVE
#define LOG_SHUTDOWNALLCORES_LEAVE(ercd)
#endif /* LOG_SHUTDOWNALLCORES_LEAVE */


/*
 *  桼Υֳ׵
 */
#ifdef TOPPERS_RaiseInterCoreInterrupt

StatusType
RaiseInterCoreInterrupt(ISRType ISRID)
{
	StatusType	ercd = E_OK;
	CCB			*p_ccb;
	CoreIdType	coreid;
	ISRCB		*p_isrcb;

	LOG_RASICI_ENTER(ISRID);
	CHECK_CALLEVEL(CALLEVEL_RAISEINTERCOREINTERRUPT);
	CHECK_ID((ISRID >= (tnum_isr2 - tnum_ici)) && (ISRID < tnum_isr2));
	p_isrcb = get_isrcb(ISRID);

	CHECK_CORE(p_isrcb->p_isrinib != NULL);
	CHECK_ACS(p_isrcb->p_isrinib->acsbtmp);
	coreid = p_isrcb->p_isrinib->p_osapinib->coreid;
	p_ccb = get_p_ccb(coreid);

	x_nested_lock_os_int();
	acquire_tsk_lock(p_ccb);

	/*
	 *  ֳߤĤƤ硤ӥåȤ򥻥åȤ塤
	 *  åȰ¸˥ֳߤ׵᤹
	 *  ֳߤػߤƤ硤ӥåȤ򥻥åȤơ
	 *  ꥿󤹤ʸ̳ߵĻˡΥӥåȤ򸫤ƽ
	 */
	p_ccb->ici_request_map |= iciinib_table[ISRID + tnum_ici - tnum_isr2].ici_bit_ptn;
	if ((p_ccb->ici_bit_mask & iciinib_table[ISRID + tnum_ici - tnum_isr2].ici_bit_ptn) != 0U) {
		target_ici_raise(coreid);
	}

	release_tsk_lock(p_ccb);
	x_nested_unlock_os_int();

  exit_no_errorhook:
	LOG_RASICI_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.isrid = ISRID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_RaiseInterCoreInterrupt);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_RaiseInterCoreInterrupt */

/*
 *  CoreID
 */
#ifdef TOPPERS_GetCoreID

CoreIdType
GetCoreID(void)
{
	CoreIdType coreid;

	LOG_GETCOREID_ENTER();
	coreid = x_core_id();
	LOG_GETCOREID_LEAVE(coreid);

	return(coreid);
}

#endif /* TOPPERS_GetCoreID */

/*
 *  AUTOSAR OSΥư
 */
#ifdef TOPPERS_StartCore

void
StartCore(CoreIdType CoreID, StatusType *Status)
{
	CCB			*p_ccb;
	CCB			*my_p_ccb;
	CoreIdType	my_coreid;
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;
#endif /* CFG_USE_ERRORHOOK */

	LOG_STARTCORE_ENTER(CoreID);
	p_ccb = get_p_ccb(OS_CORE_ID_MASTER);
	my_coreid = x_core_id();

	if (my_coreid >= TotalNumberOfCores) {
		/*
		 *  IDTotalNumberOfCores礭ϡ
		 *  CCB¸ߤʤΤǡStatusNULLʳʤ顤
		 *  顼ɥåȤreturn
		 */

		/* ĥ顼Υå */
		if (Status != NULL) {
			if (p_ccb->kerflg != FALSE) {
				/* OSư˸Ƥ */
				*Status = E_OS_ACCESS;
			}
			else if (CoreID >= TotalNumberOfCores) {
				/* ̵ʥIDꤷ */
				*Status = E_OS_ID;
			}
			else if (is_halt(CoreID) == FALSE) {
				/* ꤷ˵ưƤ */
				*Status = E_OS_STATE;
			}
			else if (x_start_core(CoreID) == FALSE) {
				/* ̵ʥIDꤷ */
				*Status = E_OS_ID;
			}
			else {
				/* ˥ư */
				activated_cores++;
				*Status = E_OK;
			}
		}
	}
	else {
		/*
		 *  OSCCB˥ƤФ줿硤
		 *  顼եå夬
		 */

		my_p_ccb = get_my_p_ccb();

		/* ĥ顼Υå */
		if (Status == NULL) {
#ifdef CFG_USE_ERRORHOOK
			ercd = OS_E_PARAM_POINTER;
#endif /* CFG_USE_ERRORHOOK */
		}
		else if (p_ccb->kerflg != FALSE) {
			/* OSư˸Ƥ */
			if (my_p_ccb->kerflg == FALSE) {
				/* ̤ưξ */
				*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
				ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
			}
			else if (PROBE_MEM_WRITE(Status, StatusType *) != FALSE) {
				/* StatusؤΥ¤ */
				*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
				ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
			}
			else {
				/* StatusؤΥ¤ʤ */
#ifdef CFG_USE_ERRORHOOK
				ercd = E_OS_ILLEGAL_ADDRESS;
#endif /* CFG_USE_ERRORHOOK */
			}
		}
		else {
			/*
			 *  OSưξ硤ø⡼ɤǸƤӽФΤǡ
			 *  *StatusѹƤɤ
			 */
			if (CoreID >= TotalNumberOfCores) {
				/* ̵ʥIDꤷ */
				*Status = E_OS_ID;
			}
			else if (is_halt(CoreID) == FALSE) {
				/* ꤷ˵ưƤ */
				*Status = E_OS_STATE;
			}
			else if (x_start_core(CoreID) == FALSE) {
				/* ̵ʥIDꤷ */
				*Status = E_OS_ID;
			}
			else {
				/* ˥ư */
				activated_cores++;
				*Status = E_OK;
				goto exit_no_errorhook;
			}
#ifdef CFG_USE_ERRORHOOK
			ercd = *Status;
#endif /* CFG_USE_ERRORHOOK */
		}

#ifdef CFG_USE_ERRORHOOK
		x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
		my_p_ccb->_errorhook_par1.coreid = CoreID;
		my_p_ccb->_errorhook_par2.status = Status;
#endif /* CFG_USE_PARAMETERACCESS */
		call_errorhook(ercd, OSServiceId_StartCore);
		x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */
	}

  exit_no_errorhook:
	LOG_STARTCORE_LEAVE(CoreID, Status);
	return;
}

#endif /* TOPPERS_StartCore */

/*
 *  AUTOSAR OSΥư
 */
#ifdef TOPPERS_StartNonAutosarCore

void
StartNonAutosarCore(CoreIdType CoreID, StatusType *Status)
{
	CCB			*p_ccb;
	CCB			*my_p_ccb;
	CoreIdType	my_coreid;
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;

	ercd = E_OK;
#endif /* CFG_USE_ERRORHOOK */

	LOG_STARTNONAUTOSARCORE_ENTER(CoreID);
	p_ccb = get_p_ccb(OS_CORE_ID_MASTER);
	my_coreid = x_core_id();

	if (my_coreid >= TotalNumberOfCores) {
		/*
		 *  OSCCBʤ˥ƤФ줿硤
		 *  顼եå夬ʤ
		 */

		/* ĥ顼Υå */
		if (Status == NULL) {
			if (is_halt(CoreID) == FALSE) {
				/* ꤷ˵ưƤ */
				if (p_ccb->kerflg != FALSE) {
					*Status = E_OS_ACCESS;
				}
				else {
					*Status = E_OS_STATE;
				}
			}
			else if (x_start_core(CoreID) == FALSE) {
				/* ̵ʥIDꤷ */
				if (p_ccb->kerflg != FALSE) {
					*Status = E_OS_ACCESS;
				}
				else {
					*Status = E_OS_ID;
				}
			}
			else {
				/* ˥ư */
				*Status = E_OK;
			}
		}
	}
	else {
		/*
		 *  OSCCB˥ƤФ줿硤
		 *  顼եå夬
		 */

		my_p_ccb = get_my_p_ccb();

		/* ĥ顼Υå */
		if (Status == NULL) {
#ifdef CFG_USE_ERRORHOOK
			ercd = OS_E_PARAM_POINTER;
#endif /* CFG_USE_ERRORHOOK */
		}
		else if (is_halt(CoreID) == FALSE) {
			/* ꤷ˵ưƤ */
			if (p_ccb->kerflg != FALSE) {
				if (my_p_ccb->kerflg == FALSE) {
					/* ̤ưξ */
					*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
				}
				else if (PROBE_MEM_WRITE(Status, StatusType *) != FALSE) {
					/* StatusؤΥ¤ */
					*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
				}
				else {
					/* StatusؤΥ¤ʤ */
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ILLEGAL_ADDRESS;
#endif /* CFG_USE_ERRORHOOK */
				}
			}
			else {
				*Status = E_OS_STATE;
#ifdef CFG_USE_ERRORHOOK
				ercd = E_OS_STATE;
#endif /* CFG_USE_ERRORHOOK */
			}
		}
		else if (x_start_core(CoreID) == FALSE) {
			/* ꤷ˵ưƤ */
			if (p_ccb->kerflg != FALSE) {
				if (my_p_ccb->kerflg == FALSE) {
					/* ̤ưξ */
					*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
				}
				else if (PROBE_MEM_WRITE(Status, StatusType *) != FALSE) {
					/* StatusؤΥ¤ */
					*Status = E_OS_ACCESS;
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ACCESS;
#endif /* CFG_USE_ERRORHOOK */
				}
				else {
					/* StatusؤΥ¤ʤ */
#ifdef CFG_USE_ERRORHOOK
					ercd = E_OS_ILLEGAL_ADDRESS;
#endif /* CFG_USE_ERRORHOOK */
				}
			}
			else {
				*Status = E_OS_ID;
#ifdef CFG_USE_ERRORHOOK
				ercd = E_OS_ID;
#endif /* CFG_USE_ERRORHOOK */
			}
		}
		else {
			/* ˥ư */
			*Status = E_OK;
			goto exit_no_errorhook;
		}

		/* 顼եåƤ */
#ifdef CFG_USE_ERRORHOOK
		x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
		my_p_ccb->_errorhook_par1.coreid = CoreID;
		my_p_ccb->_errorhook_par2.status = Status;
#endif /* CFG_USE_PARAMETERACCESS */
		call_errorhook(ercd, OSServiceId_StartNonAutosarCore);
		x_nested_unlock_os_int();
		goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
	}

  exit_no_errorhook:
	LOG_STARTNONAUTOSARCORE_LEAVE(CoreID, Status);
	return;
}

#endif /* TOPPERS_StartNonAutosarCore */

/*
 *  AUTOSAR OSΥưƤ
 */
#ifdef TOPPERS_GetNumberOfActivatedCores

uint32
GetNumberOfActivatedCores(void)
{
	LOG_GETNUMOFACTCORES_ENTER();
	LOG_GETNUMOFACTCORES_LEAVE(activated_cores);

	return(activated_cores);
}

#endif /* GetNumberOfActivatedCores */

/*
 *  OSνλ
 */
#ifdef TOPPERS_ShutdownAllCores

void
ShutdownAllCores(StatusType Error)
{
	StatusType	ercd = Error;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_SHUTDOWNALLCORES_ENTER(Error);
	/*
	 *  ƽФ° OSץꥱο/Υå
	 *  ƽФؿƥեåǤ
	 *  ShutdownAllCores() ¹Ԥ
	 */
	if (p_ccb->run_trusted == FALSE) {
		/* ꤫ƤФ줿ϥ顼եåƤ */
#ifdef CFG_USE_ERRORHOOK
		x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
		p_ccb->_errorhook_par1.error = Error;
#endif /* CFG_USE_PARAMETERACCESS */
		call_errorhook(E_OS_ACCESS, OSServiceId_ShutdownAllCores);
		x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */
	}
	else {
		/*
		 *  ʽñ̤ƤӽФ⡤ErrorE_OS_SHUTDOWN_FATALȤ
		 *  ShutdownAllCoresƤӽФΤȤơåȥԤ
		 */
		if (((p_ccb->callevel_stat & TCLMASK) | (CALLEVEL_SHUTDOWNALLCORES)) != (CALLEVEL_SHUTDOWNALLCORES)) {
			ercd = E_OS_SHUTDOWN_FATAL;
		}

		/*
		 *  OSƤʤ顼ɤꤵ줿硤ErrorE_OS_SHUTDOWN_FATALȤ
		 *  ShutdownAllCoresƤӽФΤȤơåȥԤ
		 */
		if (ercd > ERRCODE_NUM) {
			ercd = E_OS_SHUTDOWN_FATAL;
		}

		internal_shutdownallcores(ercd);
	}
	LOG_SHUTDOWNALLCORES_LEAVE(ercd);
}
#endif /* TOPPERS_ShutdownAllCores */
